#include <iostream>
using namespace std;

int main() {
    int N, Q;
    cin >> N >> Q;

    int dani[1000], pakovanja[1000];
    for (int i = 0; i < N; i++) {
        cin >> dani[i] >> pakovanja[i];
    }

    int pitanja[1000];
    for (int i = 0; i < Q; i++) {
        cin >> pitanja[i];
    }

    for (int i = 0; i < Q; i++) {
        int k = pitanja[i];
        long long ukupno = 0;

        for (int j = 0; j < N; j++) {
            if (dani[j] <= k) {
                ukupno += min(pakovanja[j], k - dani[j] + 1);
            }
        }

        cout << ukupno << endl;
    }

    return 0;
}